#!/bin/bash

set -e
function obtenerMac()
{
    local placa=$1
    local mac=`/sbin/ip link ls dev $placa|/bin/grep link.ether|/bin/sed 's/ *brd.*//g;s/.* //g'`
    echo $mac
}
function obtenerDriver()
{
    local placa=$1
    local drv=$(ethtool -i $placa|grep driver|awk '{ print $2; }')
    echo $drv
}
function mostrarLibres()
{
    echo "Placas pendientes"
    local libres=$@
    local count=1
    for i in ${libres[@]}; do
        local mac=$(obtenerMac $i)
        local drv=$(obtenerDriver $i)
        echo "$count) $mac($drv) $i"
        count=$(( count + 1 ))
    done
}
function mostrarOrden()
{
    clear
    if [ ${#ethusar[@]} -gt 0 ] ; then
        echo "Orden programado ${ethusar[@]}"
        count=0
        for i in ${ethusar[@]}; do
            local mac=${macusar[$count]}
            local drv=${drvusar[$count]}
            echo "$count) $mac($drv) $i"
            count=$(( count + 1 ))
        done
    fi
}
version=$(rpm -q $(rpm -qf /etc/redhat-release) --queryformat '%{version}\n'|cut -f 1 -d '.')
if [ "0$version" -lt "7" ];then
    echo "Este script solo se puede utilizar a partir de la version 7"
    exit -1
fi

placas=$(cat /proc/net/dev|sed 's/:.*//g'|egrep '^ *eth'|grep -v '\.')
ethlibres=(${placas[@]})
ethusar=()
macusar=()
drvusar=()
if [ ${#ethlibres[@]} -le 0 ];then
    echo "No hay placas para renombrar"
    exit -1
fi
while [ ${#ethlibres[@]} -gt 0 ];do
    mostrarOrden
    mostrarLibres ${ethlibres[@]}
    cant=${#ethlibres[@]}
    read pos
    pos=`echo $pos | sed 's/[^0-9]//g'`
    if  [ "0$pos" -lt "1" ] || [ "0$pos" -gt "$cant" ]; then
        exit
    else
        pos=$(( pos - 1 ))
        ethusar[${#ethusar[@]}]=${ethlibres[$pos]}
        macusar[${#macusar[@]}]=$(obtenerMac ${ethlibres[$pos]})
        drvusar[${#drvusar[@]}]=$(obtenerDriver ${ethlibres[$pos]})
        ethlibres=(${ethlibres[@]:0:$pos} ${ethlibres[@]:$(($pos + 1))})
    fi
done
clear
mostrarOrden
echo "Ingrese 1 para confirmar que desea usar el orden seleccionado. Cualquier otra tecla para salir"
read opcion
if [ "$opcion" != "1" ];then
    exit
fi
echo "Regenerando udev"
> /etc/udev/rules.d/70-persistent-net.rules
for ((i=${#macusar[@]} - 1; i >= 0; i--));do
    echo "ACTION==\"add\", SUBSYSTEM==\"net\", DRIVERS==\"?*\", ATTR{address}==\"${macusar[$i]}\", NAME=\"eth$i\"" >> /etc/udev/rules.d/70-persistent-net.rules
done
echo "Regenerando initramfs"
dracut -f --regenerate-all
