#!/bin/bash

obtenerEthLibre()
{
    local placa=`/bin/egrep '^ *(eth[0-9]+):' /proc/net/dev|/bin/sed 's/:.*//g;s/ *eth//'g|/bin/sort -nr|head -n1`
    if [ -z "$placa" ];then
        placa=0
    else
        placa=$((placa+1))
    fi
    echo $placa
}
obtenerMac()
{
    local placa=$1
    local mac=`/sbin/ip link ls dev $placa|/bin/grep link.ether|/bin/sed 's/ *brd.*//g;s/.* //g'`
    echo $mac
}
renombrarVirtuales()
{
    local orig=$1
    local dest=$2
    for virtual in /etc/sysconfig/network-scripts/ifcfg-$orig:* ];do
        if [ -f "$virtual" ] && [[ "$virtual" =~ ifcfg-$orig:[0-9]+$ ]];then
            local num=`/bin/echo $virtual|/bin/sed "s/.*ifcfg-$orig://g"`
            /bin/mv /etc/sysconfig/network-scripts/ifcfg-$orig:$num /etc/sysconfig/network-scripts/ifcfg-$dest:$num
            /bin/sed -i "s/$orig/$dest/g" /etc/sysconfig/network-scripts/ifcfg-$dest:$num
        fi
    done
}
renombrarConfigPlaca()
{
    local orig=$1
    local dest=$2
    local tag=$3
    if [ -n "$tag" ];then
        tag=.$tag
    fi
    /sbin/ifdown $orig$tag
    /bin/mv /etc/sysconfig/network-scripts/ifcfg-$orig$tag /etc/sysconfig/network-scripts/ifcfg-$dest$tag
    /bin/sed -i "s/$orig/$dest/g" /etc/sysconfig/network-scripts/ifcfg-$dest$tag
    renombrarVirtuales $orig$tag $dest$tag
}
renombrarConfig()
{
    local orig=$1
    local dest=$2
    for vlan in /etc/sysconfig/network-scripts/ifcfg-$orig.* ];do
        if [ -f "$vlan" ] && [[ "$vlan" =~ ifcfg-$orig.[0-9]+$ ]];then
            local tag=`/bin/echo $vlan|/bin/sed "s/.*ifcfg-$orig.//g"`
            renombrarConfigPlaca $orig $dest $tag
        fi
    done
    if [ -f /etc/sysconfig/network-scripts/ifcfg-$orig ];then
        renombrarConfigPlaca $orig $dest
    fi
}
levantarPlacas()
{
    local placa=$1
    for vlan in /etc/sysconfig/network-scripts/ifcfg-$placa.* ];do
        if [ -f "$vlan" ] && [[ "$vlan" =~ ifcfg-$placa.[0-9]+$ ]];then
            local tag=`/bin/echo $vlan|/bin/sed "s/.*ifcfg-$placa.//g"`
            /sbin/ifup $placa.$tag
        fi
    done
    if [ -f /etc/sysconfig/network-scripts/ifcfg-$placa ];then
        /sbin/ifup $placa
    fi
}
#eth=0
eth=$(obtenerEthLibre)
placas=`/bin/egrep '^ *(e[mn][0-9a-z]*):' /proc/net/dev|/bin/sed 's/:.*//g'`
for i in $placas;do
    echo "$i -> eth$eth"
    mac=$(obtenerMac $i)
    renombrarConfig $i eth$eth
    /sbin/ip link set $i down
    /sbin/ip link set $i name eth$eth
    levantarPlacas eth$eth
    echo "ACTION==\"add\", SUBSYSTEM==\"net\", DRIVERS==\"?*\", ATTR{address}==\"$mac\", NAME=\"eth$eth\"" \
        >> /etc/udev/rules.d/70-persistent-net.rules
    #eth=$((eth+1))
    eth=$(obtenerEthLibre)
done
